#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "fti2c.h"

//   // #define MAX_FREQ_CLOCK_DIVISOR 15   // equivalent to 400KHz
//   // #define MAX_FREQ_CLOCK_DIVISOR 60   // equivalent to 100KHz
#define MAX_FREQ_CLOCK_DIVISOR 79  // equivalent to 375KHz

#define WAIT 2


FTC_STATUS Status = FTC_SUCCESS;
FTC_HANDLE ftHandle;
DWORD NumDevices = 0;
DWORD dwLocationID = 0;
DWORD dwClockFrequencyHz = 0;
WriteControlByteBuffer WriteControlBuffer;
WriteDataByteBuffer WriteDataBuffer;
ReadDataByteBuffer ReadDataBuffer;
DWORD dwNumDataBytesToRead;

DWORD dwHiSpeedDeviceType = 0;
char szChannel[5];
FTC_INPUT_OUTPUT_PINS LowInputOutputPinsData;
FTH_INPUT_OUTPUT_PINS HighInputOutputPinsData;

/////////////////////////////////////////////////////////////////////
//   Function Prototypes
/////////////////////////////////////////////////////////////////////
int fti2c_test_init(void);
void fti2c_test_close(void);
void fti2c_test_measure(int *r1, int *r2, int *r3, int *r4, int *r5, int *r6);


void fti2c_test_close(){}

int fti2c_test_init(void)
{
	char szDeviceName[100];
	char szErrorMessage[100];

	//printf("step 1  -- FT2232ڑĂ邩`FbN\n");

	//Status = I2C_GetNumDevices(&NumDevices);
	Status = I2C_GetNumHiSpeedDevices(&NumDevices);
	if (Status != FTC_SUCCESS) {
		//printf("ANZXɎsB\n");
		getchar(); exit(1);
	}

	//printf("num = %d\n", NumDevices);
	if (NumDevices == 0) {
		//printf("FT2232݂ȂB\n");
		getchar(); exit(1);
	}
	
	//Status = I2C_GetDeviceNameLocID(0, szDeviceName, 100, &dwLocationID);
	Status = I2C_GetHiSpeedDeviceNameLocIDChannel(0, szDeviceName, 100, &dwLocationID, szChannel, 5, &dwHiSpeedDeviceType);
	if (Status == FTC_SUCCESS) {
		if (strcmp(szChannel, "A") != 0) { Status = FTC_DEVICE_IN_USE; }
	}
	if (Status == FTC_SUCCESS)  {
		//Status = I2C_OpenEx(szDeviceName, dwLocationID, &ftHandle);
		Status = I2C_OpenHiSpeedDevice(szDeviceName, dwLocationID, szChannel, &ftHandle);
	}
	
	if (Status != FTC_SUCCESS) {
		//printf("G[\n");
	    I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
	    //printf("Error: %s\n",szErrorMessage);
	}
	
	

	//printf("step 2 -- I2Cݒ \n");

	//printf("I2C Init\n");
	Status = I2C_InitDevice(ftHandle, MAX_FREQ_CLOCK_DIVISOR);
	if (Status == FTC_SUCCESS) {
		Status = I2C_SetDeviceLatencyTimer(ftHandle, 16);
	}
	
	if (Status != FTC_SUCCESS) {
		//printf("G[\n");
		I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
	    //printf("Error: %s\n",szErrorMessage);
	}
	
	//printf("init(2)\n");
	//Status = I2C_GetClock(MAX_FREQ_CLOCK_DIVISOR, &dwClockFrequencyHz);
	Status = I2C_GetHiSpeedDeviceClock(0, &dwClockFrequencyHz);
	if (Status == FTC_SUCCESS) {
		Status = I2C_TurnOnDivideByFiveClockingHiSpeedDevice(ftHandle);
		if (Status == FTC_SUCCESS) {
			Status = I2C_GetHiSpeedDeviceClock(0, &dwClockFrequencyHz);
			Status = I2C_SetClock(ftHandle, MAX_FREQ_CLOCK_DIVISOR, &dwClockFrequencyHz);
			if (Status == FTC_SUCCESS) {
				Status = I2C_TurnOffDivideByFiveClockingHiSpeedDevice(ftHandle);
				Status = I2C_SetClock(ftHandle, MAX_FREQ_CLOCK_DIVISOR, &dwClockFrequencyHz);
			}
		}
	}
	if (Status != FTC_SUCCESS) {
		//printf("G[\n");
		I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
	    //printf("Error: %s\n",szErrorMessage);
	}
	
	if (Status == FTC_SUCCESS) {
		Status = I2C_SetLoopback(ftHandle, false);
		if (Status == FTC_SUCCESS) {
			//Status = I2C_SetMode(ftHandle, FAST_MODE);
			Status = I2C_SetMode(ftHandle, FAST_MODE);
		}
	}
	if (Status != FTC_SUCCESS) {
		//printf("G[\n");
		I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
	    //printf("Error: %s\n",szErrorMessage);
	}
	
	
	LowInputOutputPinsData.bPin1InputOutputState = false;
	LowInputOutputPinsData.bPin1LowHighState = false;
	LowInputOutputPinsData.bPin2InputOutputState = true;
	LowInputOutputPinsData.bPin2LowHighState = true;
	LowInputOutputPinsData.bPin3InputOutputState = true;
	LowInputOutputPinsData.bPin3LowHighState = false;
	LowInputOutputPinsData.bPin4InputOutputState = true;
	LowInputOutputPinsData.bPin4LowHighState = true;
    //if (dwHiSpeedDeviceType == FT2232H_DEVICE_TYPE)
	//Status = I2C_SetHiSpeedDeviceGPIOs(ftHandle, true, &LowInputOutputPinsData, true, &HighInputOutputPinsData);
	//else
	Status = I2C_SetHiSpeedDeviceGPIOs(ftHandle, true, &LowInputOutputPinsData, false, &HighInputOutputPinsData);
	return 0;
}

void fti2c_test_measure(int *r1, int *r2, int *r3, int *r4, int *r5, int *r6)
{
	char szErrorMessage[100];
	unsigned char d1,d2,d3,d4,d5,d6;
	int x1,y1,z1;
	int x2,y2,z2;

	//printf("step 3 -- I2CeXg\n");
	
	
	//while (1) {
		// HMC6343
		
		//if (kbhit()) {
		//	if (getch()==0x1B) { break ; }
		//}
		
		WriteControlBuffer[0] = (0x32 );
		WriteDataBuffer[0] = 0x45; // measure
		//                 nh , obt@1   ,TCY,ACKKv?,t/o,stopL,WRT^Cv     , obt@2 , TCY2, ACKKv?,t/o , NULL) ;
		Status = I2C_Write(ftHandle, &WriteControlBuffer, 1, true, 20, true, BYTE_WRITE_TYPE, &WriteDataBuffer, 1, true, 20, NULL);
		if (Status != FTC_SUCCESS) {
			//printf("G[1\n");
	    	Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
		    //printf("Error: %s\n",szErrorMessage);
		}
		Sleep(WAIT); // wait 1.1msec
		
		WriteControlBuffer[0] = (0x32) + 1; // read
		dwNumDataBytesToRead=6;
		Status = I2C_Read(ftHandle, &WriteControlBuffer, 1, true, 20, BLOCK_READ_TYPE, &ReadDataBuffer, dwNumDataBytesToRead);
		if (Status != FTC_SUCCESS) {
			//printf("G[2\n");
	    	Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
		    //printf("Error: %s\n",szErrorMessage);
		}
		
		d1 = ReadDataBuffer[0];
		d2 = ReadDataBuffer[1];
		d3 = ReadDataBuffer[2];
		d4 = ReadDataBuffer[3];
		d5 = ReadDataBuffer[4];
		d6 = ReadDataBuffer[5];
		
		x1 = ( (int)d1<<8 ) + (d2);
		y1 = ( (int)d3<<8 ) + (d4);
		z1 = ( (int)d5<<8 ) + (d6);
		
		//Sleep(50);
		
		WriteControlBuffer[0] = (0x32 );
		WriteDataBuffer[0] = 0x40; // measure
		//                 nh , obt@1   ,TCY,ACKKv?,t/o,stopL,WRT^Cv     , obt@2 , TCY2, ACKKv?,t/o , NULL) ;
		Status = I2C_Write(ftHandle, &WriteControlBuffer, 1, true, 20, true, BYTE_WRITE_TYPE, &WriteDataBuffer, 1, true, 20, NULL);
		if (Status != FTC_SUCCESS) {
			//printf("G[3\n");
	    	Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
		    //printf("Error: %s\n",szErrorMessage);
		}
		Sleep(WAIT); // wait 1.1msec
		
		WriteControlBuffer[0] = (0x32) + 1; // read
		dwNumDataBytesToRead=6;
		Status = I2C_Read(ftHandle, &WriteControlBuffer, 1, true, 20, BLOCK_READ_TYPE, &ReadDataBuffer, dwNumDataBytesToRead);
		if (Status != FTC_SUCCESS) {
			//printf("G[4\n");
	    	Status = I2C_GetErrorCodeString("EN", Status, szErrorMessage, 100);
		    //printf("Error: %s\n",szErrorMessage);
		}
		
		
		d1 = ReadDataBuffer[0];
		d2 = ReadDataBuffer[1];
		d3 = ReadDataBuffer[2];
		d4 = ReadDataBuffer[3];
		d5 = ReadDataBuffer[4];
		d6 = ReadDataBuffer[5];
		
		x2 = ( (int)d1<<8 ) + (d2);
		y2 = ( (int)d3<<8 ) + (d4);
		z2 = ( (int)d5<<8 ) + (d6);
		
		//printf("X=%d,Y=%d,Z=%d , X=%d,Y=%d,Z=%d\n",x1,y1,z1,x2,y2,z2);
		
		
		//Sleep(50);
		//Sleep(500);
	//}
	
	
	if (x1>0x7FFF) { x1 -= 0x10000; }
	if (y1>0x7FFF) { y1 -= 0x10000; }
	if (z1>0x7FFF) { z1 -= 0x10000; }
	if (x2>0x7FFF) { x2 -= 0x10000; }
	if (y2>0x7FFF) { y2 -= 0x10000; }
	if (z2>0x7FFF) { z2 -= 0x10000; }
	
	//printf("I\n");
	
	*r1 = x1;
	*r2 = y1;
	*r3 = z1;
	*r4 = x2;
	*r5 = y2;
	*r6 = z2;
	
	//return 0;
}

